'''
Created on Jan 29, 2016

@author: Legendary
'''
from operator import pos
from bdb import bar
try:
    import sys
    import random
    import math
    import os
    import getopt
    import pygame
    from socket import *
    from pygame.locals import *
except ImportError, err:
    print "couldn't load module. %s" % (err)
    sys.exit(2)

ox = (0,0)
ox3 = (0,0,0)
NL = '\n'
TAB = '\t'

# Colours
colours = { 
            'background' : (140,140,140),
            'menuFont'  : (153,204,255),
            'menuSelection'  : (0,102,204),
            'debugPink' : (255,153,155),
          }

levelStates = {  
              0: "Idle",
              1: "ChooseBarrier",
              2: "AttemptBarrier",
              3: "AttackCultist",
              4: "Animation",     
              }

def incrementState (num):
    return ((num+1)%(len(levelStates)-1))

def decrementState (num):
    return ((num-1)%(len(levelStates)-1))

def getState (num):
    return levelStates[num]

def mulTuple (tup,number):
    return tuple([x*number for x in tup])

def plus2Tuple (tup1,tup2):
    return (tup1[0]+tup2[0],tup1[1]+tup2[1])

def load_img(name):
    """ Load image and return image object"""
    fullname = os.path.join('Art', name)
    try:
        image = pygame.image.load(fullname)
        if image.get_alpha() is None:
            image = image.convert()
        else:
            image = image.convert_alpha()
    except pygame.error, message:
            print 'Cannot load image:', fullname
            raise SystemExit, message
    return image, image.get_rect()

def load_sound(name):
    """ Load sound and return sound object"""
    fullname = os.path.join('Sound', name)
    try:
        sound = pygame.mixer.Sound(fullname)
        sound.set_volume(0.9)
    except pygame.error, message:
            print 'Cannot load image:', fullname
            raise SystemExit, message
    return sound, int(sound.get_length()*100)

def load_music(name):
    """ Load music and return sound object"""
    fullname = os.path.join('Music', name)
    try:
        music = pygame.mixer.Sound(fullname)
        music.set_volume(1.0)
    except pygame.error, message:
            print 'Cannot load image:', fullname
            raise SystemExit, message
    return music, int(music.get_length()*100)

def write_key(pos,text,theSurface,sz,al):
    f = pygame.font.Font('Font/dh_gentry_b.ttf',sz)
    output_text = f.render(text,True,(0,0,0))
    output_textpos = output_text.get_rect()
    if al == 0:
        output_textpos.midtop = pos
    elif al == 1:
        output_textpos.bottomright = pos
    else:
        output_textpos.center = pos
    theSurface.blit(output_text, output_textpos)   
        
def write_healthbar(pos,hp,maxhp,theSurface):
    f = pygame.font.Font('Font/IconBitOne.ttf',20)
    text = ("w"*(hp) + "v"*(maxhp-hp))*(hp%maxhp/max(hp,1))
    output_text = f.render(text,True,(255,0,0))
    output_textpos = output_text.get_rect()
    output_textpos.midbottom = pos
    theSurface.blit(output_text, output_textpos)  

class Block(object):
    def __init__(self,bar,theKey):
        self.barrier = bar
        self.id = self.barrier.get_newBlockID()
        self.open = False
        self.key = theKey
    def blockIsOpen(self):
        return self.open
    def kill(self):
        self.open = True
    def get_key(self):
        return self.key
    
class Cultist(object):
    def __init__(self,level,target_pos,key,alive,link,h=1):
        self.image,self.imrect = load_img("cultist.png")
        self.id = level.get_newAssetID()
        self.pos = target_pos
        self.animFrameCount = 0
        self.currPatchNum = 0
        self.toKey = key
        self.alive = alive
        self.linkedTo = link
        self.linkedLevel = level
        self.open = 0
        self.released = False
        self.maxhp = h
        self.hp = h
        self.attackKey = pygame.K_a
        #Create blocks for barrier
    def __str__(self):
        return "<Cultist :: Id: %d, @Pos: (%d,%d), Key: %s, OpenVal: %d, LinkedTo: %s>" % (self.id,
                                                                                           self.pos[0],
                                                                                           self.pos[1],
                                                                                           pygame.key.name(self.toKey),
                                                                                           self.open,
                                                                                           self.linkedTo.__str__()
                                                                                           )
    def update(self):
        pass
#         if self.animFrameCount > 0:
#             self.animFrameCount = (self.animFrameCount + 1 ) % 60
#             self.currPatchNum = self.animFrameCount // 6
    def draw(self,theSurface):
        if self.get_alive(): write_healthbar(plus2Tuple(plus2Tuple(self.pos, self.imrect.midtop),(20,0)),self.hp,self.maxhp,theSurface)
        theSurface.blit(self.image,self.pos)
    def kill (self):
        self.alive = False
        # TODO: Switch to death animation
    def get_alive (self): 
        return self.alive
    def get_key (self): 
        return self.toKey 
    def get_isOpen(self):
        return self.open < 1
    def incOpen(self,i=1):
        self.open = self.open + i
    def get_standHere(self):
        x, y = self.pos
        return x-0,y+10
    def getHasHP(self):
        return self.hp > 0
    def getAttackKey(self):
        return self.attackKey
    def attackSuccess(self,i=1):
        self.hp = self.hp - i
        self.hp = min (self.hp,self.maxhp)
        if not self.getHasHP():
            self.image,self.imrect = load_img("cultist2.png")   
            self.released = True
            self.linkedLevel.move_playerToAsset(self)
            self.linkedLevel.cults -= 1
    def attacking(self):
        buttons = []
        targets = map(ord,list("abcdefghijklmnorstuvwxyz0123456789"))
        for _ in range(random.randint(8,10)):
            buttons.append(random.choice(targets))
        return buttons


class Barrier(object):
    def __init__(self,level,target_pos,key,alive,link,spec = 1):
        self.image,self.imrect = load_img("barrier.png")
        self.id = level.get_newAssetID()
        self.pos = target_pos
        self.animFrameCount = 0
        self.currPatchNum = 0
        self.toKey = key
        self.alive = alive
        self.linkedTo = link
        self.linkedLevel = level
        self.open = 0
        self.released = False
        self.blocks = []
        #Create blocks for barrier
        for k in [pygame.K_1,pygame.K_2,pygame.K_3][:spec]:
            self.insertBlock(k)
            
        
    def __str__(self):
        return "<Barrier :: Id: %d, @Pos: (%d,%d), Key: %s, OpenVal: %d, LinkedTo: %s>" % (self.id,
                                                                                           self.pos[0],
                                                                                           self.pos[1],
                                                                                           pygame.key.name(self.toKey),
                                                                                           self.open,
                                                                                           self.linkedTo.__str__()
                                                                                           )
    def update(self):
        pass
#         if self.animFrameCount > 0:
#             self.animFrameCount = (self.animFrameCount + 1 ) % 60
#             self.currPatchNum = self.animFrameCount // 6
    def draw(self,theSurface):
        theSurface.blit(self.image,self.pos)
    def kill (self):
        self.alive = False
        # TODO: Switch to death animation
    def get_alive (self): 
        return self.alive
    def get_key (self): 
        return self.toKey 
    def get_isOpen(self):
        return self.open < 1
    def incOpen(self,i=1):
        self.open = self.open + i
    def get_standHere(self):
        x, y = self.pos
        return x-0, y+40
    def get_newBlockID(self):
        return len(self.blocks)
    def insertBlock(self,key):
        b = Block(self,key)
        self.blocks.append(b)
    def killBlock (self,idx):
        self.blocks[idx].kill()
        self.released = all(map(Block.blockIsOpen, self.blocks))
        if self.released:
            self.linkedLevel.move_playerToAsset(self)
            self.image,self.imrect = load_img("barrier2.png")
    def getBlockKeys(self):
        ret = [] + [(x.key,x.id) for x in self.blocks if not x.blockIsOpen()]
        return ret
        
    
class Position(object):
    def __init__(self,level,target_pos,key,alive,link):
        self.image,self.imrect = load_img("position.png")
        self.id = level.get_newAssetID()
        self.pos = target_pos
        self.animFrameCount = 0
        self.currPatchNum = 0
        self.toKey = key
        self.alive = alive
        self.linkedTo = link
        self.linkedLevel = level
        self.open = 0
        self.released = True
    def __str__(self):
        return "<Position :: ID: %d, @Pos: (%d,%d), Key: %s, OpenVal: %d, LinkedTo: %s>" % (self.id,
                                                                                            self.pos[0],
                                                                                            self.pos[1],
                                                                                            pygame.key.name(self.toKey),
                                                                                            self.open,
                                                                                            self.linkedTo.__str__()
                                                                                            )
    def update(self):
        pass
#         if self.animFrameCount > 0:
#             self.animFrameCount = (self.animFrameCount + 1 ) % 60
#             self.currPatchNum = self.animFrameCount // 6
    def draw(self,theSurface):
        theSurface.blit(self.image,self.pos)
    def kill (self):
        self.alive = False
        # TODO: Switch to death animation
    def get_alive (self): 
        return self.alive
    def get_key (self): 
        return self.toKey 
#     def get_goto (self): 
    def get_isOpen(self):
        return self.open < 1
    def incOpen(self,i=1):
        self.open = self.open + i
    def get_standHere(self):
        x, y = self.pos
        return x,y

class Player(object):
    def __init__(self,player_pos=(-50,-50)):
        self.image,self.imrect = load_img("character2.png")
        self.pos = player_pos
        self.currAssetID = -1
    def __str__(self):
        return "<Player :: @Pos: (%d,%d), @AssetID: %d>"%(self.pos[0],self.pos[1],self.currAssetID)
    def draw(self,theSurface):
        theSurface.blit(self.image,self.pos)
    def set_pos(self,newpos):
        self.pos = newpos
    def set_currAssetId(self,idx):
        self.currAssetID = idx
        
        
class Level(object):
    def __init__(self,assets,nocult):
        self.listOfAssets = []
        self.usedKeys = []
        self.player = Player()
        self.cults = nocult
        for (ch,p,k,a,l,x) in assets:
            if ch == "P":
                self.insert(Position(self,p,k,a,l))
            elif ch =="C":
                self.insert(Cultist(self,p,k,a,l,x))
            elif ch =="B":
                self.insert(Barrier(self,p,k,a,l,x))
            else:
                raise ValueError("Unknown Asset Code!")
        self.ready()  
        self.move_playerToAsset(self.listOfAssets[0]) 
           
        
    def insert(self,asset):
        if asset.get_key() in self.usedKeys:
            raise ValueError("The key '%s' is already in use!"%(pygame.key.name(asset.get_key())))
        else:
            self.usedKeys.append(asset.get_key())
            self.listOfAssets.append(asset)
    def __str__(self):
        s = "<Level:: Asset count: %d>"%(len(self.listOfAssets))
        for x in self.listOfAssets:
            s=s+NL+TAB+x.__str__()
        return s
    def get_newAssetID(self):
        return len(self.listOfAssets)
    def get_assetObj(self,idx):
        return self.listOfAssets[idx]
    def ready(self):
        for a in self.listOfAssets:
            for ax in a.linkedTo:
                self.listOfAssets[ax].incOpen()
    def get_openAssets(self):
        o = [x for x in self.listOfAssets if x.get_isOpen()]
        return o
    def move_playerToAsset(self,asset):
        newpos = asset.get_standHere()
        self.player.set_pos(newpos)
        self.player.set_currAssetId(asset.id)
        if asset.released:
            for linkedId in asset.linkedTo:
                self.listOfAssets[linkedId].incOpen(-1)
            asset.linkedTo = []       
    def draw_alive(self,surface):
        for a in self.listOfAssets:
            if a.get_alive():
                a.draw(surface)
            else:
                pass
        self.player.draw(surface)
    def draw_healthbars(self,surface):
        for a in [x for x in self.listOfAssets if x == Cultist]:
            if a.getHasHP():
                a.draw_healthbar()
    def draw_availableKeys(self,surface):
        for t,k,(a,_) in self.get_keys():
            #(pos,key,z,theSurface)
            if t == "Move": #want this on BR aka 3
                write_key(plus2Tuple(plus2Tuple(a.get_standHere(),self.player.imrect.midbottom),(0,-25)), pygame.key.name(k),surface,80,0)
            if t == "KillBlock": #want this on BR aka 3
                theText = ""
                for x in map(pygame.key.name,[x[0] for x in a.getBlockKeys()]):
                    theText = theText+ x
                write_key(plus2Tuple(a.get_standHere(),self.player.imrect.topleft), theText,surface,60,1)
            if t == "HurtCultist": #want this on BR aka 3
                theText = ""
                if a.getHasHP:
                    theText = theText+pygame.key.name(k)
                write_key(plus2Tuple(a.get_standHere(),self.player.imrect.topleft), theText,surface,60,1)
                
        
    def get_keys(self):
        movements = [] + [("Move",x.get_key(),(x,-1)) for x in self.listOfAssets if x.get_isOpen()]
        barriers = []
        cultists = []
        if type(self.listOfAssets[self.player.currAssetID]) == Barrier and not self.player.currAssetID < 0:
            x =self.listOfAssets[self.player.currAssetID]
            for k,i in self.listOfAssets[self.player.currAssetID].getBlockKeys():
                barriers.append( ("KillBlock",k,(x,i)) )
        if type(self.listOfAssets[self.player.currAssetID]) == Cultist and not self.player.currAssetID < 0:
            x =self.listOfAssets[self.player.currAssetID]
            if x.getHasHP():
                cultists.append( ("HurtCultist",x.getAttackKey(),(x,-1)) )
        a_keys = movements + barriers + cultists
        return a_keys
    def kill_block(self,theBarrier,theBlockID):
        theBarrier.killBlock(theBlockID)
    def attack_cultist(self,theCultist):
        return theCultist.attacking()
#         theCultist.attackSuccess()
        

            